#````````````````````````````
#  fR[h
#````````````````````````````
sub decode {
	&ReadParse;

	foreach (keys %in) {
		if ($_ ne 'img' && $_ ne 'useskin') {
			$in{$_} =~ tr/+/ /;
			$in{$_} =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

			$in{'len1'} = $in{$_} if ($_ eq 'outline');
			$in{'len2'} = $in{$_} if ($_ eq 'text');

			$in{$_} =~ s/&/&amp;/g;
			$in{$_} =~ s/"/&quot;/g;
			$in{$_} =~ s/'/&#39;/g;
			$in{$_} =~ s/\//&#47;/g;
			$in{$_} =~ s/\./&#046;/g;
			$in{$_} =~ s/\t/  /g;
			$in{$_} =~ s/\0//g;

			if ($_ ne 'news') {
				$in{$_} =~ s/</&lt;/g;
				$in{$_} =~ s/>/&gt;/g;
			}

			$in{$_} =~ s/\r\n|\r|\n/<br>/g;

			# ^O
			if (($_ eq 'text' || $_ eq 'message') and !$notag) {
				#my $tag = join ('|', @oktag);
				$in{$_} =~ s/&lt;(\/?($oktag).*?)&gt;/<$1>/ig;
			}

			&jcode::convert(\$in{$_},'sjis');
		}
	}

	return %in;
}

#````````````````````````````
#  ݒf[^ǂݍ
#````````````````````````````
sub config_read {
	my @config = &file_read("$configdat");

	($cgititle, $mtsregist, $msmail, $ranking, $viewcnt, $votecnt, $newnovel, $maxrank, $maxpage, $rmaxpage,
	 $genretr, $typeyom, $typeren, $typerel, $download, $useml, $maxtitle, $userss, $revwcnt) = split (/\t/, $config[0]);
	($genresel, $categorysel, $genre, $cateadd, $maxoutline, $maxtext, $mintext, $notag, $oktag, $renwd) = split (/\t/, $config[1]);
	($imgup, $okimg, $imgmxsz, $imgwid, $imghei, $oversz, $skinok, $skinup, $skinmxsz) = split (/\t/, $config[2]);
	($reviewfunc, $reviewboard, $reviewtype, $rankstm, $rank, $reviewmax, $asciideny, $kinsiword) = split (/\t/, $config[3]);
	($mobile_ac, $mobile_body, $m_newnovel, $outlinelength, $textlength, $m_maxtitle, $m_maxrank, $m_maxpage,
	 $rmaxtitle, $p_maxtitle, $maxreview) = split (/\t/, $config[4]);
	#($refurl, $usedeny, $deny, $deny2, $jumpurl, $denyms, $endeny) = split (/\t/, $config[6]);

	@genre = split (/<>/, $genre);
	@okimg = split (/\|/, $okimg);
	@rank = split (/<>/, $rank);
	@kinsiword = split (/<>/, $kinsiword);
	#@deny = split (/\|/, $deny);
	#@deny2 = split (/\|/, $deny2);
}

#````````````````````````````
#  OĂяo
#````````````````````````````
sub outac {
	# t@Cǂݍ
	my @allnovel = &file_read("$allnovel");

	my $tmp = "<a href=\"http://$ENV{'SERVER_NAME'}$ENV{'SCRIPT_NAME'}?\">$cgititle</a>V<br>";

	my $i = 0;
	foreach (@allnovel) {
		# ԍ,yl[,ID,,,^Cg,쐬,XV,炷,JeS,W,{,[,z,UPtO,tO
		my ($no, $pname, $id, $sts, $type, $title, $startd, $endd) = split (/\t/, $_);

		next if ($sts != 2);

		$tmp .= "E<a href=\"http://$ENV{'SERVER_NAME'}$ENV{'SCRIPT_NAME'}?mode=view&no=$no&id=$id\">$title</a>i<a href=\"http://$ENV{'SERVER_NAME'}$ENV{'SCRIPT_NAME'}?mode=profile&id=$id\">$pname</a>j[$endd]<br>";

		last if (++$i == $FORM{'view'});
	}

	# o
	print "Content-type: text/javascript\n\n";
	print "document.write('<small>$tmp</small>');";
}

#````````````````````````````
#  RSS
#````````````````````````````
sub rss {
	print "Content-type: text/xml\n\n";
	print qq(<?xml version="1.0" encoding="shift_jis"?>
	<rss version="2.0">
	<channel>
	<link>http://$ENV{'SERVER_NAME'}$ENV{'SCRIPT_NAME'}</link>
	<language>ja-jp</language>
	);

	if ($FORM{'id'}) {
		#  [U[
		my ($user, @novel) = &file_read("./$FORM{'id'}/user.dat");

		# ԍ,yl[,Mail,URL,[U[ID,pX[h,zXg,Rg,o^,ŏIM,i,[,[M
		my ($no, $pname, $endd) = (split(/\t/, $user))[0, 1, 9];

		my $date = &rss_decode($endd, $no);

		print qq(
		<title>$pnamȅ</title>
		<lastBuildDate>$date</lastBuildDate>
		);

		my %title;
		my @item;
		my $i = 0;
		foreach (@novel) {
			# ԍ,yl[,ID,,,^Cg,쐬,XV,炷,JeS,W,{,[,z,UPtO,tO
			my ($no, $pname, $id, $sts, $type, $title, $startd, $endd, $outline_mn, $category, $genre, $view, $vote, $revw, $up, $end) = split (/\t/, $_);

			$TITLE{$no} = $title if ($type == 2);
			#$NO{$mn}    += 1 if ($type == 4);

			next if ($sts != 2);

			my $date = &rss_decode($endd, $no);

			my $sub = ($TITLE{$outline_mn}) ? "u$TITLE{$outline_mn}v" : $outline_mn;

			unshift (@item, qq(
			<item>
			<title>$title</title>
			<description><![CDATA[$sub]]></description>
			<link>http://$ENV{'SERVER_NAME'}$ENV{'SCRIPT_NAME'}?mode=view&amp;no=$no&amp;id=$id</link>
			<guid>http://$ENV{'SERVER_NAME'}$ENV{'SCRIPT_NAME'}?mode=view&amp;no=$no&amp;id=$id</guid>
			<pubDate>$date</pubDate>
			</item>
			));
		}

		# 10܂ŕ\
		print join ('', @item[0..9]);
	} else {
		#  SĂ̏
		my @novel = &file_read("$allnovel");

		# ԍ,yl[,Mail,URL,[U[ID,pX[h,zXg,Rg,o^,ŏIM,i,[,[M
		my ($no, $endd) = (split(/\t/, $novel[0]))[0, 7];

		my $date = &rss_decode($endd, $no);

		print qq(
		<title>$cgititle</title>
		<lastBuildDate>$date</lastBuildDate>
		);

		my $i = 0;
		foreach (@novel) {
			# ԍ,yl[,ID,,,^Cg,쐬,XV,炷,JeS,W,{,[,z,UPtO,tO
			my ($no, $pname, $id, $sts, $type, $title, $startd, $endd, $outline, $category, $genre, $view, $vote, $revw, $up, $end) = split (/\t/, $_);

			next if ($sts != 2);

			my $date = &rss_decode($endd, $no);

			print qq(
			<item>
			<title>$title</title>
			<description><![CDATA[$outline]]></description>
			<link>http://$ENV{'SERVER_NAME'}$ENV{'SCRIPT_NAME'}?mode=view&amp;no=$no&amp;id=$id</link>
			<guid>http://$ENV{'SERVER_NAME'}$ENV{'SCRIPT_NAME'}?mode=view&amp;no=$no&amp;id=$id</guid>
			<pubDate>$date</pubDate>
			</item>
			);
		}
	}

	print qq(</channel></rss>);
}

# RSS2.0fR[h
sub rss_decode {
	my @mon = ('','Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
	my @week = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');

	my ($days, $times) = split(/\ /, $_[0]);
	my ($year, $mon, $day) = split(/\//, $days);
	my ($hour, $min) = split(/:/, $times);
	$year = '20'.$year if (length($year) == 2);
	$mon =~ s/^0*//ig;

	my ($y, $m, $d) = ($year, $mon, $day);
	if ($m < 3) { --$y; $m+=12; }
	my $w = ($y+int($y/4)-int($y/100) + int($y/400)+int((13*$m+8)/5)+$d) %7;

	my $sec = sprintf("%02\d", $_[1]); # b͋L^ĂȂ̂ŏԍőp

	my $date = "$week[$w], $day $mon[$mon] $year $hour:$min:$sec +0900";

	return $date;
}

#````````````````````````````
#  _E[h
#````````````````````````````
sub download { # txt_E[h
	# t@Cǂݍ
	my ($novel, @review) = &file_read("./$FORM{'id'}/$FORM{'no'}.dat");

	# ԍ,yl[,ID,,,^Cg,,align,҃bZ[W,쐬,XV,C^Cgԍ,Ae,C,tO
	my ($pname, $title, $text) = (split (/\t/, $novel))[1, 5, 6];

	$text =~ s/<br( \/)*>/\n/g;

	# _E[h_CAOo悤ɂďo
	print "Content-type: text/download\n";
	print "Content-disposition: attachment; filename=\"novel.txt\"\n\n";
	print <<"_TEXT_";
^CgF$title
ҁF$pname
-------------------------------------{-------------------------------------
$text
------------------------------------------------------------------------------
_TEXT_
}

sub downloadskin { # QlpXLiftHg$skindefotopgpj
	# XLt@Cǂݍ
	my $skin = join ("\n", &file_read("$skindir$skindefotop"));

	# _E[h_CAOo悤ɂďo
	print "Content-type: text/download\n";
	print "Content-disposition: attachment; filename=\"skin.html\"\n\n";
	print $skin;
}

#````````````````````````````
#  摜TCY
#````````````````````````````
sub img_size {
	my ($wid, $hei) = @_;

	if ($wid > $imgwid || $hei > $imghei) {
		if ($oversz) {
			# 摜TCYK蒴ĂΒ
			$wid = $imgwid if ($wid > $imgwid);
			$hei = $imghei if ($hei > $imghei);
		} else {
			&error("}G̃TCY傫܂B");
		}
	}

	return ($wid, $hei);
}

#````````````````````````````
#  摜Abv[h
#````````````````````````````
sub img_write {
	my ($no, $file, $img) = @_;
	my $flg;

	foreach (@okimg) {
		if ($file =~ /(.+\.$_)$/i) {
			&lock if ($lock);
			open(FILE, ">./$FORM{'id'}/$no\.$_") || &error("摜̃Abv[hɎs܂B");
				binmode (FILE);
				print FILE $img;
			close(FILE);
			&unlock if ($lock);
			$flg = $_;
			last;
		}
	}
	if (!$flg) { &error("Abv[hsȃt@CłB"); }

	return $flg;
}

#````````````````````````````
#  XLAbv[h
#````````````````````````````
sub skin_write {
	my ($no, $file, $skin) = @_;

	if ($file =~ s/(.+\.html)$//i) {
		&lock if ($lock);
		open(FILE, ">./$FORM{'id'}/$no\.html") || &error("XL̃Abv[hɎs܂B");
			print FILE $skin;
		close(FILE);
		&unlock if ($lock);
	} else {
		&error("Abv[hsȃt@CłB");
	}
}

#````````````````````````````
#  XLfR[h
#````````````````````````````
sub skin_decode {
	my ($sample, $no, $html, $maint, $title, $type, $text, $sdays, $ldays, $pname, $message, $chap) = @_;

	if ($sample) {
		if ($html =~ s/<!-- PAGE a=(.+) b=(.+?)( c=(.+))* -->(.+)<!-- \/PAGE -->/<!-- PAGE -->/s) {
			my $page;
			my ($b, $n) = ($2, $5);
			foreach (1..5) {
				my $tmp = $n;

				my $cnt = sprintf ("%0$b\d", $_);

				if ($_ == 1 && $1 == 1) {
					$tmp =~ s/<\/*a.*?>//gs;
				} else {
					$tmp =~ s/_ANCHOR_/$script?mode=sample&type=4&html=$FORM{'html'}/s;
				}

				$tmp =~ s/_TITLE_/Aڏ$_/s;
				$tmp =~ s/_DAYS_/00\/00\/00/s;
				$tmp =~ s/_NO_/$cnt/gs;

				$page .= $tmp;
			}
			$html =~ s/<!-- PAGE -->/$page/gs;
		}

		$html =~ s/<!-- MOKUJI -->(.+?)(_ANCHOR_)(.+?)<!-- \/MOKUJI -->/$1$script?mode=sample&type=2&html=$FORM{'html'}$3/gs;
		$html =~ s/<!-- BACK a=(.+?) -->(.+?)(_ANCHOR_)(.+?)<!-- \/BACK -->/$2#$4/gs;
		$html =~ s/<!-- NEXT a=(.+?) -->(.+?)(_ANCHOR_)(.+?)<!-- \/NEXT -->/$2#$4/gs;
	}

	$html =~ s/_CGI_TITLE_/$cgititle/g; # bfh^Cg
	$html =~ s/_STYLE_/$style/;         # X^CV[gt@C
	$html =~ s/_CHAPTER_/$chap/g;       # `v^[
	$html =~ s/_MAIN_TITLE_/$maint/g;   # C^Cg
	$html =~ s/_TITLE_/$title/g;        # ^Cg
	$html =~ s/_TYPE_/$type/g;          # 
	$html =~ s/_TEXT_/$text/;           # {
	$html =~ s/_MESSAGE_/$message/;     # ҃bZ[W
	$html =~ s/_START_DAYS_/$sdays/g;   # 쐬
	$html =~ s/_LAST_DAYS_/$ldays/g;    # XV
	$html =~ s/_NAME_/$pname/g;         # yl[

	$html =~ s/_TOP_ANCHOR_/$script?/g; # gbvy[WAJ[

	# vtB[AJ[
	if (!$sample) {
		$html =~ s/_PROFILE_ANCHOR_/$1$script?mode=profile&id=$FORM{'id'}$3/g;
	} else {
		$html =~ s/_PROFILE_ANCHOR_/$1#$3/g;
	}

	# ҃bZ[W
	if ($message) {
		$html =~ s/<!-- MESSAGE -->(.*?)(_VALUE_)(.*?)<!-- \/MESSAGE -->/$1$message$3/gs;
	} else {
		$html =~ s/<!-- MESSAGE -->(.+?)<!-- \/MESSAGE -->//gs;
	}

	# z
	if ($reviewfunc) {
		if (!$sample) {
			$html =~ s/<!-- REVIEW -->(.+?)(_ANCHOR_)(.+?)<!-- \/REVIEW -->/$1$script?mode=review_view&mn=$no&no=$FORM{'no'}&id=$FORM{'id'}$3/gs;
		} else {
			$html =~ s/<!-- REVIEW -->(.+?)(_ANCHOR_)(.+?)<!-- \/REVIEW -->/$1#$3/gs;
		}
	} else {
		$html =~ s/<!-- REVIEW -->(.+?)<!-- \/REVIEW -->//gs;
	}

	# [
	if ($votecnt) {
		if (!$sample) {
			$html =~ s/<!-- VOTE -->(.+?)(_ANCHOR_)(.+?)<!-- \/VOTE -->/$1$script?mode=vote&id=$FORM{'id'}&no=$no$3/gs;
		} else {
			$html =~ s/<!-- VOTE -->(.+?)(_ANCHOR_)(.+?)<!-- \/VOTE -->/$1#$3/gs;
		}
	} else {
		$html =~ s/<!-- VOTE -->(.+?)<!-- \/VOTE -->//gs;
	}

	# RSS
	if ($userss) {
		if (!$sample) {
			$html =~ s/<!-- RSS -->(.+?)(_ANCHOR_)(.+?)<!-- \/RSS -->/$1$script?mode=rss&id=$FORM{'id'}$3/gs;
		} else {
			$html =~ s/<!-- RSS -->(.+?)(_ANCHOR_)(.+?)<!-- \/RSS -->/$1#$3/gs;
		}
	} else {
		$html =~ s/<!-- RSS -->(.+?)<!-- \/RSS -->//gs;
	}

	# [o^
	if ($useml) {
		if (!$sample) {
			$html =~ s/<!-- SENDMAIL -->(.+?)(_ANCHOR_)(.+?)<!-- \/SENDMAIL -->/$1$script?mode=mail&no=$no&id=$FORM{'id'}$3/gs;
		} else {
			$html =~ s/<!-- SENDMAIL -->(.+?)(_ANCHOR_)(.+?)<!-- \/SENDMAIL -->/$1#$3/gs;
		}
	} else {
		$html =~ s/<!-- SENDMAIL -->(.+?)<!-- \/SENDMAIL -->//gs;
	}

	# txt_E[h
	if ($download) {
		if (!$sample) {
			$html =~ s/<!-- DOWNLOAD -->(.+?)(_ANCHOR_)(.+?)<!-- \/DOWNLOAD -->/$1$script?mode=download&id=$FORM{'id'}&no=$FORM{'no'}$3/gs;
		} else {
			$html =~ s/<!-- DOWNLOAD -->(.+?)(_ANCHOR_)(.+?)<!-- \/DOWNLOAD -->/$1#$3/gs;
		}
	} else {
		$html =~ s/<!-- DOWNLOAD -->(.+?)<!-- \/DOWNLOAD -->//gs;
	}

	# 쌠\
	$html =~ s/_COPY_/<font size="-2"><a href="http:\/\/goo\.gl\/kxtdN" target="_blank">܂₩e[ Ver$version<\/a><\/font>/gs;

	return $html;
}

#````````````````````````````
#  vr[
#````````````````````````````
sub preview {
	my $fname = ($FORM{'rno'}) ? "./$FORM{'id'}/img_$FORM{'no'}_$FORM{'rno'}" : "./$FORM{'id'}/img_$FORM{'no'}";

	if ($incfn{'img'}) {
		# V摜
		if ($incfn{'img'} !~ /.+:\\.\..+/) {
			# [JpX擾oȂꍇ
			$FORM{'text'} =~ s/##img##/<img alt="ɉ摜}܂B" align="$FORM{'align'}">/g;
		} else {
			# u
			$FORM{'text'} =~ s/##img##/<img src="$incfn{'img'}" alt="摜">/g;
		}
	} elsif (-e <$fname.*>) {
		# ̉摜Ε\
		foreach (@okimg) {
			if (-e "$fname.$_") {
				$FORM{'text'} =~ s/##img##/<img src="$fname\.$_" alt="摜">/g;
			}
		}
	}

	#my $divwid = $winw - 50;

	# XLt@Cǂݍ
	my $html = ($FORM{'useskin'}) ? $FORM{'useskin'} : join("\n", &file_read("$skindir$skinfilenov[$FORM{'skin'}]"));

	$html = &skin_decode(1, 0, $html, 'C^Cg', $tempname[$FORM{'skin'}], 'vr[', $FORM{'text'}, '00/00/00', '00/00/00', 'yl[', $FORM{'message'}, 1);

	print "Content-type: text/html\n\n";
	print $html;
}

#````````````````````````````
#  XLTv
#````````````````````````````
sub frame { # t[
	print "Content-type: text/html\n\n";
	print <<"_HTML_";
<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
	<title>$cgititle|XLTv</title>
	<meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS">
</head>
<frameset rows="30, *">
	<frame src="$script?mode=menu&type=$FORM{'type'}" name="menu" scrolling="no" marginheight="4" marginwidth="0">
	<frame src="$script?mode=sample&type=$FORM{'type'}&html=0" name="main" marginheight="10">
<noframes>
</noframes>
</frameset>
</html>
_HTML_
}

sub menu { # j[
	print "Content-type: text/html\n\n";
	print <<"_HTML_";
<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS">
	<link rel="stylesheet" type="text/css" href="$style">
<script language=javascript>
<!--
function jump(j){
	n = "$script?mode=sample&type=$FORM{'type'}&html=";
	parent.main.location.href = n + j;
}
//-->
</script>
</head>
<body>
<center>
<select onchange="jump(this.options[this.selectedIndex].value)">
_HTML_
	foreach (0..$#tempname) {
		print qq(<option value="$_">$tempname[$_]</option>);
	}
print <<"_HTML_";
</select>
<small>[<a href="javascript:window.parent.close()"></a>]</small>
</center>
</body>
</html>
_HTML_
}

sub sample { # CiTv\j
	my @tmpf = ($FORM{'type'} == 2) ? @skinfiletop : @skinfilenov;

	# XLt@Cǂݍ
	my $html = join("\n", &file_read("$skindir$tmpf[$FORM{'html'}]"));

	$text = <<'_HTML_';
ȖB<br><br>
a̎ނāAL`Ɏ̕֋Aƍsڂ_ĂB<br>
ЕGc̏ɓ˂āAS~ĂƂAԂ̂悤ȒqςƎh̑ɗBɕςƖ邭ȂB<br><br>
͕̉̕MłBZA߂ƂāAނȋv}Xēy̏ʂB<br>
ɂ͊C̎ĂBcÂł܂ɏLĂB<br>
LXՂƂāAlCȂBVɍۍs̊ۂeAr[ɐĂ悤ɌB<br><br>
G܂܁A̎ōcāAEŌƁAvɁAƂB<br>
ΈSAcƂ̂ƂāȀɂǂ荿B<br><br>
O͎łBȂʂ͂͂Ȃ낤Ƙa]B<br>
܂łʂƂČƁAO͎ł͂܂ƌB<br>
lԂ̋ƌB͂͂{ȂƉ]ď΂B<br>
ɂΌ؋ėƉ]ĂՂƌނB<br>
B<br><br>
Ėڟ΁@y\z
_HTML_

	$message = <<'_HTML_';
ȖB<br><br>
a̎ނāAL`Ɏ̕֋Aƍsڂ_ĂB<br>
ЕGc̏ɓ˂āAS~ĂƂAԂ̂悤ȒqςƎh̑ɗBɕςƖ邭ȂB<br><br>
Ėڟ΁@y\z
_HTML_

	$html = &skin_decode(1, 0, $html, 'C^Cg', $tempname[$FORM{'html'}], 'vr[', $text, '00/00/00', '00/00/00', 'yl[', $message, 1);

	print "Content-type: text/html\n\n";
	print $html;
}

#````````````````````````````
#  JeS
#````````````````````````````
sub category {
	my ($n, $usctg) = @_;
	my @usctg = split (/\t/, $usctg);
	my $category;
	foreach (0..$#usctg) {
		if ($FORM{"cgry$n\_$_"}) {
			$category .= "," if ($category);
			$category .= "$usctg[$_]";
		}
	}
	#my $category = join (',', grep ($FORM{"cgry$n\_$_"}, @usctg));
	if ($FORM{"newcgry$n"}) {
		if (grep ($FORM{"newcgry$n"} eq $_, @usctg)) {
			&error("ǉꂽJeS͊ɑ݂܂B");
		}
		$FORM{"newcgry$n"} =~ s/\,/\./g;
		$category .= "," if ($category);
		$category .= "$FORM{\"newcgry$n\"}";
		$usctg .= "\t" if ($usctg);
		$usctg .= $FORM{"newcgry$n"};
	}

	return ($usctg, $category);
}

#````````````````````````````
#  wb_[
#````````````````````````````
sub header {
	my ($title, $java) = @_;

	print "Content-type: text/html\n\n";
	print qq(
	<html>
	<head>
	<meta http-equiv="Content-type" content="text/html; charset=shift_jis">);
	print qq(<link rel="alternate" type="application/rss+xml" title="RSS" href="$script?mode=rss" />) if ($userss);
	print qq(<link rel="stylesheet" type="text/css" href="$style">
	<title>$cgititle|$title</title>
	);

	&java if ($java);

	print qq(</head><body);

	print " $mobile_body" if ($mobile);

	print qq(><center>);
}

#````````````````````````````
#  tb^[
#````````````````````````````
sub footer {
	print <<"_HTML_";
</center>
<div align="right">
<font size="-2"><a href="http://goo.gl/kxtdN" target="_blank">܂₩e[ Ver$version</a></font>
</div>
</body>
</html>
_HTML_
}

#````````````````````````````
#  JavaScript
#````````````````````````````
sub java {
	print <<"_JAVA_";
<script language="javascript">
<!--
function rnsview(no) {
	rns = document.getElementsByTagName('tr')
	for (i = 0; i < rns.length; ++i) {
		if (rns[i].id == "rns"+no) {
			if (rns[i].style.display == "") {
				rns[i].style.display = "none";
			} else if (rns[i].style.display == "none") {
				rns[i].style.display = "";
			}
		}
	}
}

function preview(mode) {
	document.form.target = "win";
	document.form.mode.value = "preview";
	win = window.open("about:blank","win","scrollbars=yes,status=no,directories=no,menubar=no,resizable=yes,toolbar=no");
	document.form.submit();
	document.form.mode.value = mode;
	document.form.target = "";
}

function txtrsize(ud) {
	if (ud == 1) {
		document.form.text.rows += 5;
	} else {
		document.form.text.rows -= 5;
	}
}

function check() {
	var txt = document.form.text.value;
	txt = txt.replace(/\\r\\n/g, "");
	txt = txt.replace(/\\n/g, "");
	txt = txt.replace(/##img##/g, "");
	txt = txt.replace(/<.+?>/g, "");
	var len = txt.length;
	if (($maxtext && len > $maxtext) || ($mintext && len < $mintext)) {
		len = "<font color=\\"#CC3333\\">"+len+"</font>";
	}
	document.getElementById('cnt').innerHTML = len;
}

function delcheck() {
    if (confirm("u"+document.form.title.value+"v폜܂B\\n\\n낵łH")) {
        return true;
    } else {
        return false;
    }
}

function showhide(id){
	spn = document.getElementsByTagName('span');
	for (i = 0; i < spn.length; ++i) {
		if (spn[i].style.display == "block") {
			spn[i].style.display = "none";
		} else if (spn[i].style.display == "none") {
			spn[i].style.display = "block";
		}
	}
}
// -->
</script>
_JAVA_
}

#````````````````````````````
#  zXgl
#````````````````````````````
sub get_host {
	my ($addr, $host) = ($ENV{'REMOTE_ADDR'}, $ENV{'REMOTE_HOST'});

	if ($host eq $addr || !$host) {
		$host = gethostbyaddr(pack("C4", split(/\./,$addr)), 2) || $addr;
	}

	return $host;
}

#==============================================
#  ANZX`FbN
#==============================================
sub access_check {
	if ($refurl && (!$ENV{'HTTP_REFERER'} or $ENV{'HTTP_REFERER'} !~ /^$refurl/) || $ENV{'REQUEST_METHOD'} ne 'POST') {
		&error("sȃANZXłB");
	}
	if ($endeny && $ENV{'HTTP_ACCEPT_LANGUAGE'} !~ /^(ja)/i) {
		&error('ERROR!');
	}
}

#==============================================
#  NbL[o
#==============================================
sub set_cookie {
	my ($mode, @cook) = @_;
	my (@mons, @week, $date, $cook);
	my ($sec, $min, $hour, $mday, $mon, $year, $wday) = gmtime(time + $cvalid*24*60*60);

	@mons = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
	@week = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
	$date = sprintf("%s, %02d\-%s\-%04d %02d:%02d:%02d GMT",
						$week[$wday], $mday, $mons[$mon], $year+1900, $hour, $min, $sec);

	if ($mode == 1) {
		# OC
		print "Set-Cookie: MTS1=id\:$cook[0]\,lgpass\:$cook[1]; expires=$date\n";
	} elsif ($mode == 2) {
		# zbZ[W
		print "Set-Cookie: MTS2=rvname\:$cook[0]\,mail\:$cook[1]; expires=$date\n";
	} elsif ($mode == 3) {
		# [
		print "Set-Cookie: MTS3=ryname\:$cook[0]\,rypass\:$cook[1]; expires=$date\n";
	} elsif ($mode == 4) {
		# [
		print "Set-Cookie: MTS4=kick\:$cook[0]; expires=$date\n";
	} elsif ($mode == 5) {
		# Ǘҗp
		print "Set-Cookie: MTS5=mskey\:$cook[0]; expires=$date\n";
	}
}

#==============================================
#  NbL[ǂݏo
#==============================================
sub get_cookie {
	my ($name, $value, @pairs, %DUMMY, %COOKIE);

	@pairs = split(/\;/, $ENV{'HTTP_COOKIE'});

	foreach (@pairs) {
		($name, $value) = split(/\=/, $_);
		$name =~ s/ //g;
		$DUMMY{$name} = $value;
	}

	@pairs = split(/\,/, "$DUMMY{'MTS1'},$DUMMY{'MTS2'},$DUMMY{'MTS3'},$DUMMY{'MTS4'},$DUMMY{'MTS5'}");

	foreach (@pairs) {
		($name, $value) = split(/\:/, $_);
		$COOKIE{$name} = $value;
	}

	return %COOKIE;
}

#````````````````````````````
#  ANZX
#````````````````````````````
sub deny {
	my ($denyflg);

	for (my $i = 0; $i < ((@deny)+(@deny2)); $i++) {
		# IPzXg
		if ($deny[$i]) {
			$deny[$i] =~ s/\./\\./g; $deny[$i] =~ s/\*/\.\*/g;
			if ($host =~ /$deny[$i]/i) { $denyflg = 1; last; }
		}

		# Cookie
		if ($deny2[$i]) {
			if ($COOKIE{'id'} eq $deny2[$i]) { $denyflg = 1; last; }
		}
	}

	if ($denyflg) {
		if ($jumpurl) {
			print "Location: $jumpurl\n\n";
		} else {
			&error($denyms);
		}
	}
}

#````````````````````````````
#  t@Cǂݍ
#````````````````````````````
sub file_read {
	my ($file) = @_;

	open (FILE, "$file") || &error("t@C\"$file\"J܂łB");
		flock (FILE, 1) if ($lock == 1 && $oplock);
		my @line = <FILE>;
	close (FILE);

	chomp (@line);

	return @line;
}

#````````````````````````````
#  t@C
#````````````````````````````
sub file_write {
	my ($file, @data) = @_;

	open (FILE, "+< $file") || &error("t@C\"$file\"J܂łB");
	flock (FILE, 2) if ($lock == 1);
	seek (FILE, 0, 0) if ($lock == 1);
	foreach (@data) {
		print FILE "$_\n";
	}
	truncate (FILE, tell (FILE)) if ($lock == 1);
	close (FILE);
}

#````````````````````````````
#  t@C݁iVK쐬j
#````````````````````````````
sub new_file_write {
	my ($file, @data) = @_;

	open (FILE, ">$file") || &error("t@C\"$file\"J܂łB");
		foreach (@data) {
			print FILE "$_\n";
		}
	close (FILE);
}

#````````````````````````````
#  pX[hÍ
#````````````````````````````
sub encrypt {
	my ($pass) = @_;

	my $xx = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
	      . "abcdefghijklmnopqrstuvwxyz"
                 . "0123456789./";
	my $salt = substr($xx, int(rand(64)), 1);
	$salt .= substr($xx, int(rand(64)), 1);
	my $pwd = crypt($pass, $salt);

	return $pwd;
}

#````````````````````````````
#  F؊mF
#````````````````````````````
sub pass_check {
	my ($pass, $pwd) = @_;

	my $salt = substr($pwd,0,2);

	if (!$pass) {
		&error("pX[h͂Ă܂B");
	} elsif (!$pwd) {
		&error("pX[h͓o^Ă܂B");
	} elsif ($pwd ne crypt($pass, $salt)) {
		&error("pX[hԈĂ܂B");
	}
}

#````````````````````````````
#  bN
#````````````````````````````
sub lock {
	# 3ȏÂbN͉
	if (-e $lockdir) {
		my $mtime = (stat($lockdir))[9];
		if ($mtime < time - 60*3) { &unlock; }
	}

	my $retry = 5;

	while (!mkdir($lockdir, 0755)) {
		if (--$retry <= 0) {
			&error('rW[ԂłB΂炭҂ĂēxMĂB');
		}
		sleep(1);
	}

	$lockflg = 1;
}

#````````````````````````````
#  bN
#````````````````````````````
sub unlock {
	rmdir($lockdir);
	$lockflg = 0;
}

#````````````````````````````
#  tl
#````````````````````````````
sub get_days {
	my ($time) = @_;

	my ($sec, $min, $hour, $day, $mon, $year, $wday, $yday, $isdst) = gmtime($time+60*60*9);
	#my @week = ('','','','','','','y');

	my $days = sprintf("%04d/%02d/%02d %02d:%02d", $year+1900, $mon+1, $day, $hour, $min);

	#my $days = sprintf("%04d/%01d/%01d", $year+1900, $mon+1, $dy);

	substr ($days,0,$dayscut) = '';

	return $days;
}

#````````````````````````````
#  G[
#````````````````````````````
sub error {
	&error_mobile(@_) if ($mobile);

	&unlock if ($lockflg);

	&header("error|$cgititle");

	print qq(
	<div class="top">
	<div class="head">G[</div>
	<div class="cell">
	<p><table align="center"><tr><td><font color="#CC3333">G[</font><br>
	);

	foreach (@_) {
		print qq(<font color="#CC3333">&gt;&nbsp;</font>$_<br>);
	}

	print qq(
	</td></tr></table></p>
	<p align="center"><a href="javascript:history.back();">߂</a></p>
	</div>
	</div>
	</body></html>
	);

	exit;
}

#````````````````````````````
#  G[igсj
#````````````````````````````
sub error_mobile {
	&unlock if ($lockflg);

	&header("error|$cgititle");

	print qq(
	</center>
	<div align=left>
	<font color=#CC3333>G[<br>
	);
	foreach (@_) {
		print qq(&gt;&nbsp;$_<br>);
	}
	print qq(
	</font>
	<hr>
	߂{^Ŗ߂ĂB
	<hr>
	<a href=$s_mobile?>TOP</a>
	</div>
	</body></html>
	);

	exit;
}

1;